unit SimpleGraph; //droite cercle point spline bezier implicit
interface
 uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;
  
const CRLF:string=chr(13)+chr(10);
type
  TSimpleGraphForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label7: TLabel;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    function Valider: Boolean;
  end;

var
  SimpleGraphForm: TSimpleGraphForm;

implementation
uses Unite1, listes2, complex3, analyse4, graph1_6, graph2_7, surface8, saisies, Unit1;

{$R *.dfm}

procedure TSimpleGraphForm.Button1Click(Sender: TObject);
begin
     if Valider then ModalResult:=mrOk;
end;

procedure TSimpleGraphForm.Button3Click(Sender: TObject);
begin
     MainForm.GestionAttributs(Edit1.text);
     Button1.SetFocus
end;

procedure TSimpleGraphForm.FormCreate(Sender: TObject);
var p:Pelement;
begin
     digits:=12;
     p:=CurrentGraph;
     if currentCat=cat_utilisateur
                    then
                        begin
                                Width:=550;
                                BorderStyle:=bsSizeable
                        end;
     Edit1.Text:=CurrentName;
     if p<>nil
        then
            begin
                 if currentCat=cat_utilisateur
                    then memo1.text:=p^.LigneCommande
                    else Edit2.text:=p^.LigneCommande;
                 case currentCat of
                 cat_label: edit3.text:=PLabel(p)^.texte;
                 cat_polygone: begin
                                 edit3.text:=Streel(PLigne(p)^.rayon);
                                 Checkbox1.checked:=(Pligne(p)^.fermee=1);
                            end;
                 cat_arc: Checkbox1.checked:=(Parc(p)^.sens=1);
                 cat_equadif: RadioGroup1.ItemIndex:=Pequadif(p)^.mode;
                 end;
                 p^.lireAttributs;
            end else
                    begin
                         DefaultSettings;
                         Edit2.Text:='';
                         memo1.text:='';
                         case currentCat of
                         cat_label: edit3.text:='';
                         cat_polygone: begin
                                            edit3.text:='0';
                                            Checkbox1.checked:=false;
                                       end;
                         cat_arc: Checkbox1.checked:=true;
                         cat_equadif: RadioGroup1.ItemIndex:=0;
                         cat_surface: begin edit2.text:='[  ,  ,  , 5*(-1+i), 5*(-1+i), 25*(1+i), 1]';
                                            FillStyle:=1; PFillStyle^.affixe^.x:=1;
                                      end;
                         end;

                    end;
     Case CurrentCat of
     cat_dot: begin
                      Caption:='Point ou nuage de points';
                      memo2.text:='Commande est une expression qui renvoie une liste de complexes (affixes).'
                      +CRLF+'Pour un nuage de points A1, A2..., An, tapez: [A1,A2,...,An]'
                      +CRLF+CRLF+'Exemple: [-1, 1+2*i, 3*exp(i*pi/4)]';
               end;
     cat_droite: begin
                      Caption:='Droite';
                      memo2.text:='Droite passant par deux points A et B, tapez: [A, B]  (ex: [3-i, 1+2*i] )'
                      +CRLF+'Droite passant par A et dirige par le vecteur V, tapez: [A, A+V]'
                      +CRLF+'Droite d''quation ax+by=c, tapez: [a, b, c]'
                      +CRLF+CRLF+'Exemple: [0, 1+i]';
                 end;
     cat_Cercle: begin
                      Caption:='Cercle';
                      memo2.text:='Cercle de centre A et de rayon R, tapez: [A, R]'
                      +CRLF+'Cercle de centre A et passant par B, tapez: [A, abs(B-A)]'
                      +CRLF+'Cercle passant par A, B et C, tapez: [A, B, C]'
                      +CRLF+CRLF+'Exemple: [0, 2]';
                 end;
     cat_Spline: begin
                      Caption:='Spline cubique';
                      memo2.text:='La commande est une expression de la forme [V1,A1,A2,...,An,Vn] avec:'
                      +CRLF+'A1,...An: la liste des points interpols par la spline,'
                       +CRLF+'V1: vecteur vitesse au point A1'
                      +CRLF+'et Vn: vecteur vitesse au point An (0 = pas de contrainte, extremit libre).'
                      +CRLF+CRLF+'Exemple: [0, -1, i, 1, 2-i, 0]';
                 end;
     cat_bezier: begin
                      Caption:='Courbe de Bezier';
                      memo2.text:='[A1,A2,A3]: on aura une courbe de Bzier  3 points.'+CRLF+
                      '[A1,A2,A3,A4,...,A(3n+1)]: successions de courbes de Bzier joingnant les points A1, A4, A7, ..., A(3n+1),'+
                      'les autres points sont des points de contrle. '+
                      'Deux points contrles successifs peuvent tre remplacs par un jump, dans ce cas la courbe de Bzier '+
                      ' est remplace par un segment.'
                      +CRLF+CRLF+ 'Exemple: [-2, -1+i, i, 1, jump, 1-i, jump, -2-i, jump, -2]';
                 end;
     cat_implicit: begin
                      Caption:='Courbe implicite f(x,y)=0';
                      memo2.text:='La commande est une expression de la forme f(x,y) ou [f(x,y), n, m], avec:'
                      +CRLF+'n: le nombre d''intervalles (subdivision) en abscisse (50 par dfaut),'
                      +CRLF+'et m: le nombre d''intervalles (sbdivision) en ordonne (50 par dfaut).'
                      +CRLF+CRLF+'Exemple: sin(x*y)';
                 end;
     cat_Label: begin
                      Caption:='Label';
                      Label3.Caption:='Affixe=';
                      Edit2.left:=edit1.Left; edit2.width:=edit1.width;
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-7;
                      memo2.text:='Le texte est une chaine de caractres'
                      +CRLF+CRLF+'Exemple: Ceci est un label';
                      Label7.Caption:='Texte=';
                      Label7.visible:=true;
                      Edit3.visible:=true;
                 end;
     cat_polygone: begin
                      Caption:='Ligne polygonale';
                      Label7.Caption:='Rayon=';
                      Edit3.Width:=Edit1.Width;
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-5;
                      memo2.text:='Pour une ligne polyg. A1, A2..., An, tapez la commande: [A1,A2,...,An]'
                      +CRLF+'Pour des <coins> arrondis donner un rayon >0.'
                      +CRLF+CRLF+'Exemple: [1, 1+i, 2-3*i]';
                      Label7.visible:=true;
                      Edit3.visible:=true;
                      checkBox1.visible:=true;
                 end;
     cat_Arc: begin
                      Caption:='Arc de cercle';
                      CheckBox1.left:=Edit1.left;
                      CheckBox1.Caption:='Sens trigo';
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-7;
                      memo2.text:='Arc BAC de centre A de rayon R, tapez: [B, A, C, R]'
                      +CRLF+CRLF+'Exemple: [1, 0, 1+i, 2]';
                      CheckBox1.visible:=true;
                 end;
     cat_Utilisateur: begin
                      Caption:='Elment graphique utilisateur';
                      Memo1.visible:=true;
                      Edit2.visible:=false;
                      memo2.visible:=false;
                 end;
     cat_Equadif: begin
                      Caption:='Equation diffrentielle: x''(t)+iy''(t)= f(t,x,y)';
                      RadioGroup1.visible:=true;
                      RadioGroup1.top:=memo2.top-7;
                      RadioGroup1.height:=memo2.height+7;
                      memo2.left:=RadioGroup1.left+Radiogroup1.Width+2;
                      memo2.Width:=Edit3.left+Edit3.width-memo2.left;
                      memo2.text:='Avec les conditions initiales: x(t0)=x0 et y(t0)=y0'
                      +CRLF+'tapez la commande: [f(t,x,y), t0, x0+i*y0]'
                      +CRLF+CRLF+'Exemple: [1+i*y, 0, i]';
                 end;
     cat_surface: begin
                      Caption:='Surface paramtre par u et v';
                      memo2.text:='[x(u,v), y(u,v), z(u,v), uMin+i*uMax, vMin+i*vMax, uNbLg+i*vNbLg, degrad].'
                      +CRLF+CRLF+'Les paramtres 4 et 5 sont les intervalles pour u et v.'+CRLF+
                      'Le paramtre 6 est le nombre de lignes pour u et v.'+
                       CRLF+'Le paramtre 7 indique un dgrad ou non des couleurs (1 ou 0).'
                       +CRLF+CRLF+'Exemple: [(3+cos(v))*cos(u), (3+cos(v))*sin(u), sin(v), pi*(-1+i), pi*(-1+i), 35*(1+i), 1]';
                 end;

     end;
     digits:=4;
end;

function TSimpleGraphForm.Valider:boolean;
var nom:Tnom;
    p,q:Pelement;
    f:Pexpression;
    R:real;
    sens:integer;
    commande:string;
begin
     Valider:=true;
     nom:=Edit1.text;
     p:=CurrentGraph;
     if NomValide(nom,p<>nil) then
           begin
                 new(f,init);
                 if CurrentCat=cat_utilisateur
                    then commande:=Memo1.text
                    else commande:=Edit2.text;
                 if not f^.definir(commande)
                    then
                        begin
                             Messagedlg(ErrorMessage,mtWarning,[mbok],0);
                             if CurrentCat=cat_utilisateur
                                then begin
                                     Memo1.selStart:=ErrorPos-1;
                                     Memo1.SelLength:=1; Memo1.SetFocus
                                     end
                                else begin
                                     Edit2.selStart:=ErrorPos-1;
                                     Edit2.SelLength:=1;
                                     Edit2.SetFocus;
                                     end;
                             Valider:=false
                        end
                    else
                         begin
                              //if p<>nil then liste_element.supprimer(Pcellule(p));
                              case CurrentCat of
                              cat_dot: q:=new(PDot,init(Nom,Edit2.Text));
                              cat_droite: q:=new(PDroite,init(Nom,Edit2.Text));
                              cat_cercle: q:=new(PCercle,init(Nom,Edit2.Text));
                              cat_implicit: q:=new(PImplicit,init(Nom,Edit2.Text));
                              cat_bezier: q:=new(PBezier,init(Nom,Edit2.Text));
                              cat_spline: q:=new(PSpline,init(Nom,Edit2.Text));
                              cat_utilisateur: q:=new(Putilisateur,init(Nom,commande,-1));
                              cat_label:  q:=new(PLabel,init(Nom,Edit2.Text,Edit3.text));
                              cat_surface: q:=new(Psurface,init(Nom,Edit2.Text));
                              cat_polygone:  if validReal(edit3,0,reel_Max,R) then
                                            q:=new(Pligne,init(Nom,Edit2.text,byte(Checkbox1.checked),R))
                                            else begin Valider:=false; dispose(f,detruire); exit end;
                              cat_arc:  begin
                                               if checkbox1.checked then sens:=1 else sens:=-1;
                                               q:=new(PArc,init(Nom,Edit2.Text,sens));
                                        end;
                              cat_equadif:  q:=new(PEquadif,init(Nom,Edit2.Text,RadioGroup1.ItemIndex));
                              end;
                              if p=nil then ajouter_element(q)
                                       else begin
                                                 liste_element.inserer(q,p);
                                                 liste_element.supprimer(Pcellule(p));
                                            end;
                         end;
                 dispose(f,detruire)
           end
           else begin
                     Messagedlg(Edit1.text+': nom invalide ou dj pris!',mtWarning,[mbok],0);
                     Edit1.selectAll; Edit1.SetFocus; Valider:=false
                end
end;

end.
