{Copyright (C) 2005-2006 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence 
Publique Gnrale GNU publie par la Free Software Foundation (version 2 ou bien toute autre version 
ultrieure choisie par vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spcifique.
 Reportez-vous  la Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme temps que ce programme;
 si ce n'est pas le cas, crivez  la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, tats-Unis.
 }


UNIT Unite1; {calculs sur les rels}

INTERFACE

CONST
      version='1.9';
      
      reel_max=1.0E+308;       {fourchette des rels positifs}
      reel_min=1.0E-324;

function    ajouter(x,y:real):real;      {oprations avec tests d'erreurs}
function soustraire(x,y:real):real;
function multiplier(x,y:real):real;
function    diviser(x,y:real):real;
function  puissance(x,y:real):real;

function sqr(x:real):real;               {fonctions avec tests d'erreurs}
function sqrt(x:real):real;
function exp(x:real):real;
function ln(x:real):real;
function tan(x:real):real;
function arcsin(x:real):real;
function arccos(x:real):real;
function  sh(x:real):real;
function  ch(x:real):real;
function  th(x:real):real;
function argsh(x:real):real;
function argch(x:real):real;
function argth(x:real):real;

function Ceil(X: real): Integer;
function Floor(X: real): Integer;
function Min(A,B: real): real;


VAR CalcError:boolean;                {indicateur d'erreur de calcul}

IMPLEMENTATION
     
{================================}
function ajouter(x,y:real):real;
begin
     if ((x<=0) and (y>=0)) or ((x>=0) and (y<=0)) then ajouter:=x+y
             else
     if abs(x)>reel_max-abs(y) then CalcError:=true
             else
     ajouter:=x+y
end;
{=============================================================================}
function soustraire(x,y:real):real;
begin
     soustraire:=ajouter(x,-y)
end;
{=============================================================================}
function multiplier(x,y:real):real;
begin
     if (x=0) or (y=0) then multiplier:=0
             else
     if (abs(x)<=1) or (abs(y)<=1) then multiplier:=x*y
             else
     if abs(x)>(reel_max/abs(y)) then CalcError:=true
             else
     multiplier:=x*y
end;
{=============================================================================}
function diviser(x,y:real):real;
begin 
     if y=0 then CalcError:=true
             else
     if abs(y)>=1 then diviser:=x/y
             else
     if abs(x)>abs(y)*reel_max then CalcError:=true
             else
     diviser:=x/y
end;
{=============================================================================}
function puissance_entiere(x,p:real):real;
begin
     if p=0 then if x=0 then CalcError:=true
                        else puissance_entiere:=1
            else
     if p>0 then if p-1<0 then CalcError:=true
                          else
     if x=0 then puissance_entiere:=0
                          else
     if frac(p/2)<>0 then
     puissance_entiere:=multiplier(x,puissance_entiere(x,p-1))
               else
     puissance_entiere:=sqr(puissance_entiere(x,p/2))
            else
     if x=0 then CalcError:=true
            else
     puissance_entiere:=diviser(1,puissance_entiere(x,-p))
end;
{=============================================================================}
function exp(x:real):real;
begin
     if x<0 then exp:=diviser(1,exp(-x))
            else
     if x>system.ln(reel_max) then CalcError:=true
            else
     exp:=system.exp(x)
end;
{=============================================================================}
function puissance(x,y:real):real;
begin
     if int(y)<>y then if x<=reel_min then CalcError:=true
                               else
     puissance:=exp(multiplier(y,system.ln(x)))
                  else
     puissance:=puissance_entiere(x,y)
end;
{=============================================================================}
function sqr(x:real):real;
begin
      if abs(x)<=system.sqrt(reel_max) then sqr:=system.sqr(x)
                                       else CalcError:=true
end;
{=============================================================================}
function sqrt(x:real):real;
begin
      if x<0 then CalcError:=true
             else sqrt:=system.sqrt(x)
end;
{=============================================================================}
function ln(x:real):real;
begin
      if x<=0 then CalcError:=true
             else ln:=system.ln(x)
end;
{=============================================================================}
function tan(x:real):real;
begin
     Result:=diviser(sin(x),cos(x));
end;
{=============================================================================}
function arcsin(x:real):real;
begin
     if abs(x)>1 then CalcError:=true
                 else
                     if abs(x)=1 then arcsin:=pi/2*x
                                 else
                                arcsin:=arctan(x/system.sqrt(1-x*x))
end;
{=============================================================================}
function arccos(x:real):real;
begin
     arccos:=pi/2-arcsin(x)
end;
{=============================================================================}
function sh(x:real):real;

begin
     Result:=exp(x);
     Result:=soustraire(Result,diviser(1,Result))/2
end;
{=============================================================================}
function ch(x:real):real;
begin
      Result:=exp(x);
      Result:=ajouter(Result,diviser(1,Result))/2
end;
{=============================================================================}
function th(x:real):real;
begin
      result:=exp(multiplier(2,x));
      th:=diviser(ajouter(1,result),ajouter(-1,result))
end;
{============================================================================}
function argsh(x:real):real;
begin
      result:=ajouter(1,multiplier(x,x));
      if not CalcError then begin
                           result:=ajouter(x,system.sqrt(result));
                           if not CalcError then result:=system.ln(result);
                      end;
end;
{=============================================================================}
function argch(x:real):real;
begin
      if x<1 then CalcError:=true
            else
            begin
                 result:=soustraire(multiplier(x,x),1);
                 if not CalcError then begin
                                       result:=ajouter(x,system.sqrt(result));
                                       if not CalcError then result:=system.ln(result);
                                  end;
           end;
end;
{=============================================================================}
function argth(x:real):real;
begin
      if (x<=-1) or (x>=1) then CalcError:=true
                          else
                          begin
                               result:=diviser(1+x,1-x);
                               if not CalcError then result:=system.ln(result)/2;
                         end;
end;
{=============================================================================}
function Ceil(X: real): Integer;
begin
  Result := Integer(Trunc(X));
  if Frac(X) > 0 then
    Inc(Result);
end;

function Floor(X: real): Integer;
begin
  Result := Integer(Trunc(X));
  if Frac(X) < 0 then
    Dec(Result);
end;

function Min(A,B: real): real;
begin
  if A < B then
    Result := A
  else
    Result := B;
end;
end.